/* This is not my own code!
 * Source for occupancy Masks: http://www.rivalchess.com/magic-bitboards/
 * Source for magic bitboards: http://chessprogramming.wikispaces.com/Looking+for+Magics Author: Tord Romstad
 * Josh Feener's chess program.
 * These arrays are for rook and bishop moves using magic bitboards .
*/


   long occupancyMaskRook[] = {
        0x101010101017eL,
        0x202020202027cL,
        0x404040404047aL,
        0x8080808080876L,
        0x1010101010106eL,
        0x2020202020205eL,
        0x4040404040403eL,
        0x8080808080807eL,
        0x1010101017e00L,
        0x2020202027c00L,
        0x4040404047a00L,
        0x8080808087600L,
        0x10101010106e00L,
        0x20202020205e00L,
        0x40404040403e00L,
        0x80808080807e00L,
        0x10101017e0100L,
        0x20202027c0200L,
        0x40404047a0400L,
        0x8080808760800L,
        0x101010106e1000L,
        0x202020205e2000L,
        0x404040403e4000L,
        0x808080807e8000L,
        0x101017e010100L,
        0x202027c020200L,
        0x404047a040400L,
        0x8080876080800L,
        0x1010106e101000L,
        0x2020205e202000L,
        0x4040403e404000L,
        0x8080807e808000L,
        0x1017e01010100L,
        0x2027c02020200L,
        0x4047a04040400L,
        0x8087608080800L,
        0x10106e10101000L,
        0x20205e20202000L,
        0x40403e40404000L,
        0x80807e80808000L,
        0x17e0101010100L,
        0x27c0202020200L,
        0x47a0404040400L,
        0x8760808080800L,
        0x106e1010101000L,
        0x205e2020202000L,
        0x403e4040404000L,
        0x807e8080808000L,
        0x7e010101010100L,
        0x7c020202020200L,
        0x7a040404040400L,
        0x76080808080800L,
        0x6e101010101000L,
        0x5e202020202000L,
        0x3e404040404000L,
        0x7e808080808000L,
        0x7e01010101010100L,
        0x7c02020202020200L,
        0x7a04040404040400L,
        0x7608080808080800L,
        0x6e10101010101000L,
        0x5e20202020202000L,
        0x3e40404040404000L,
        0x7e80808080808000L
   };

   long occupancyMaskBishop[] = {
        0x40201008040200L,
        0x402010080400L,
        0x4020100a00L,
        0x40221400L,
        0x2442800L,
        0x204085000L,
        0x20408102000L,
        0x2040810204000L,
        0x20100804020000L,
        0x40201008040000L,
        0x4020100a0000L,
        0x4022140000L,
        0x244280000L,
        0x20408500000L,
        0x2040810200000L,
        0x4081020400000L,
        0x10080402000200L,
        0x20100804000400L,
        0x4020100a000a00L,
        0x402214001400L,
        0x24428002800L,
        0x2040850005000L,
        0x4081020002000L,
        0x8102040004000L,
        0x8040200020400L,
        0x10080400040800L,
        0x20100a000a1000L,
        0x40221400142200L,
        0x2442800284400L,
        0x4085000500800L,
        0x8102000201000L,
        0x10204000402000L,
        0x4020002040800L,
        0x8040004081000L,
        0x100a000a102000L,
        0x22140014224000L,
        0x44280028440200L,
        0x8500050080400L,
        0x10200020100800L,
        0x20400040201000L,
        0x2000204081000L,
        0x4000408102000L,
        0xa000a10204000L,
        0x14001422400000L,
        0x28002844020000L,
        0x50005008040200L,
        0x20002010080400L,
        0x40004020100800L,
        0x20408102000L,
        0x40810204000L,
        0xa1020400000L,
        0x142240000000L,
        0x284402000000L,
        0x500804020000L,
        0x201008040200L,
        0x402010080400L,
        0x2040810204000L,
        0x4081020400000L,
        0xa102040000000L,
        0x14224000000000L,
        0x28440200000000L,
        0x50080402000000L,
        0x20100804020000L,
        0x40201008040200L
   };


const U64 RMagic[64] = {
  0x2080020500400f0ULL,
  0x28444000400010ULL,
  0x20000a1004100014ULL,
  0x20010c090202006ULL,
  0x8408008200810004ULL,
  0x1746000808002ULL,
  0x2200098000808201ULL,
  0x12c0002080200041ULL,
  0x104000208e480804ULL,
  0x8084014008281008ULL,
  0x4200810910500410ULL,
  0x100014481c20400cULL,
  0x4014a4040020808ULL,
  0x401002001010a4ULL,
  0x202000500010001ULL,
  0x8112808005810081ULL,
  0x40902108802020ULL,
  0x42002101008101ULL,
  0x459442200810c202ULL,
  0x81001103309808ULL,
  0x8110000080102ULL,
  0x8812806008080404ULL,
  0x104020000800101ULL,
  0x40a1048000028201ULL,
  0x4100ba0000004081ULL,
  0x44803a4003400109ULL,
  0xa010a00000030443ULL,
  0x91021a000100409ULL,
  0x4201e8040880a012ULL,
  0x22a000440201802ULL,
  0x30890a72000204ULL,
  0x10411402a0c482ULL,
  0x40004841102088ULL,
  0x40230000100040ULL,
  0x40100010000a0488ULL,
  0x1410100200050844ULL,
  0x100090808508411ULL,
  0x1410040024001142ULL,
  0x8840018001214002ULL,
  0x410201000098001ULL,
  0x8400802120088848ULL,
  0x2060080000021004ULL,
  0x82101002000d0022ULL,
  0x1001101001008241ULL,
  0x9040411808040102ULL,
  0x600800480009042ULL,
  0x1a020000040205ULL,
  0x4200404040505199ULL,
  0x2020081040080080ULL,
  0x40a3002000544108ULL,
  0x4501100800148402ULL,
  0x81440280100224ULL,
  0x88008000000804ULL,
  0x8084060000002812ULL,
  0x1840201000108312ULL,
  0x5080202000000141ULL,
  0x1042a180880281ULL,
  0x900802900c01040ULL,
  0x8205104104120ULL,
  0x9004220000440aULL,
  0x8029510200708ULL,
  0x8008440100404241ULL,
  0x2420001111000bdULL,
  0x4000882304000041ULL,
};

const U64 BMagic[64] = {
  0x100420000431024ULL,
  0x280800101073404ULL,
  0x42000a00840802ULL,
  0xca800c0410c2ULL,
  0x81004290941c20ULL,
  0x400200450020250ULL,
  0x444a019204022084ULL,
  0x88610802202109aULL,
  0x11210a0800086008ULL,
  0x400a08c08802801ULL,
  0x1301a0500111c808ULL,
  0x1280100480180404ULL,
  0x720009020028445ULL,
  0x91880a9000010a01ULL,
  0x31200940150802b2ULL,
  0x5119080c20000602ULL,
  0x242400a002448023ULL,
  0x4819006001200008ULL,
  0x222c10400020090ULL,
  0x302008420409004ULL,
  0x504200070009045ULL,
  0x210071240c02046ULL,
  0x1182219000022611ULL,
  0x400c50000005801ULL,
  0x4004010000113100ULL,
  0x2008121604819400ULL,
  0xc4a4010000290101ULL,
  0x404a000888004802ULL,
  0x8820c004105010ULL,
  0x28280100908300ULL,
  0x4c013189c0320a80ULL,
  0x42008080042080ULL,
  0x90803000c080840ULL,
  0x2180001028220ULL,
  0x1084002a040036ULL,
  0x212009200401ULL,
  0x128110040c84a84ULL,
  0x81488020022802ULL,
  0x8c0014100181ULL,
  0x2222013020082ULL,
  0xa00100002382c03ULL,
  0x1000280001005c02ULL,
  0x84801010000114cULL,
  0x480410048000084ULL,
  0x21204420080020aULL,
  0x2020010000424a10ULL,
  0x240041021d500141ULL,
  0x420844000280214ULL,
  0x29084a280042108ULL,
  0x84102a8080a20a49ULL,
  0x104204908010212ULL,
  0x40a20280081860c1ULL,
  0x3044000200121004ULL,
  0x1001008807081122ULL,
  0x50066c000210811ULL,
  0xe3001240f8a106ULL,
  0x940c0204030020d4ULL,
  0x619204000210826aULL,
  0x2010438002b00a2ULL,
  0x884042004005802ULL,
  0xa90240000006404ULL,
  0x500d082244010008ULL,
  0x28190d00040014e0ULL,
  0x825201600c082444ULL,
};

int magicNumberShiftsRook[] = {
52,
53,53,53,53,53,53,
52,
53,
54,54,54,54,54,54,
53,53,
54,54,54,54,54,54,
53,53,
54,54,54,54,54,54,
53,53,
54,54,54,54,54,54,
53,53,
54,54,54,54,54,54,
53,53,
54,54,54,54,54,54,
53,
52,
53,53,53,53,53,53,
52
};

int magicNumberShiftsBishop[] = {
58,
59,59,59,59,59,59,
58,
59,59,59,59,59,59,59,59,59,59,
57,57,57,57,
59,59,59,59,
57,
55,55,
57,
59,59,59,59,
57,
55,55,
57,
59,59,59,59,
57,57,57,57,
59,59,59,59,59,59,59,59,59,59,
58,
59,59,59,59,59,59,
58
};
